<?php

include_once ROOTPATH."/../expressoMail1_2/inc/class.imap_functions.inc.php";
require_once ROOTPATH.'/library/uuid/class.uuid.php';


class ImapServiceAdapter extends imap_functions/* implements Service*/
{
    public function open( $config )
    {
		$this->init();
    }

//     public function connect( $config )
//     {
// 			$this->init();
//     }
	
    public function find( $URI, $justthese = false, $criteria = false )
	{ 
		$context = $justthese['context'];
		$URI = $URI['concept'];

		switch( $URI )
		{
			case 'folder':
			{
				$result = $this->to_utf8($this->get_folders_list());

				foreach ($result as $res) {

					$response[] = array(
							'id' => $res['folder_id'],
							'commonName' => $res['folder_name'],
							'parentFolder' => $res['folder_parent'],
							'messageCount' => array('unseen' => isset($res['folder_unseen']) ? $res['folder_unseen'] : null, 'total' => null)
						);
				}

				return $response;
			}
			case 'message':
			{
				//begin: for grid	
				$page  = $criteria['page']; //{1}    get the requested page
				$limit = $criteria['rows']; //{10}   get how many rows we want to have into the grid
				$sidx  = $criteria['sidx']; //{id}   get index row - i.e. user click to sort
				$sord  = $criteria['sord']; //{desc} get the direction

				$filter = $criteria['filter'];

				if( !$sidx ) $sidx = 1;

				$folder_name = str_replace( '.', $this->imap_delimiter, $context['folder'] );
				
				$count = imap_num_msg( $this->open_mbox( $folder_name ) );

				$total_pages = $count > 0 ? ceil( $count/$limit ) : 0;

				if( $page > $total_pages )
					$page = $total_pages;

				$start = $limit * $page - $limit;

				// do not put $limit*($page - 1)
				//end: for grid

				if( $filter )
				{
					if( $filter[0] !== 'msgNumber' )
					{
					for( $i = 0; $i < count($filter); $i++ )
					{
						if( count( $filter[$i] ) === 4 )
						$criteria['isExact'] = ( array_shift( $filter[$i] ) === 'AND' );

						$criteria[ $filter[$i][0] ] = array( 'criteria' => $filter[$i][2], 'filter' => $filter[$i][1] );
					}

					return $this->searchSieveRule($criteria);
					}

					$msgNumber = array();

					for( $i = $start; $i < $start + $limit && isset( $filter[2][$i] ); $i++ )
					  $msgNumber[] = $filter[2][$i];

					if( empty( $msgNumber ) )
					return( false );

					$result = $this->get_info_msgs( array( 'folder' => $folder_name, 
									   'msgs_number' => implode( ',', $msgNumber ) ) );

					foreach( $result as $i => $val )
					$result[$i] = unserialize( $val );

				}
				else
				{
					$result = $this->get_range_msgs2( 
						array( 
							'folder' => $folder_name, //INBOX
							'msg_range_begin' => $start + 1, //??
							'msg_range_end' => $start + $limit, //$limit = $_GET['rows']; // get how many rows we want to have into the grid
							'sort_box_type' => 'SORTARRIVAL', 
							'search_box_type' => 'ALL',
							'sort_box_reverse' => 1 
						) 
					);
				}
				//return var_export($result);

				$response = array( "page" => $page, "total" => $total_pages, "records" => $count );
				
				for ($i=0; $i<count($result); $i++)
				{
					$flags_enum = array('Recent', 'Unseen',  'Answered',  'Draft',  'Deleted', 'Flagged');

					foreach ($flags_enum as $key => $flag)
					{
						if ( !isset($result[$i][$flag]) || !trim($result[$i][$flag]) || trim($result[$i][$flag]) == '') 
							unset($flags_enum[$key]);

						unset($result[$i][$flag]);
					}

					if (array_key_exists($i, $result))
					{
						$response["rows"][$i] = $result[$i];
						$response["rows"][$i]['timestamp'] = ( ( $result[$i]['udate'] + $this->functions->CalculateDateOffset() ) * 1000 );
						$response["rows"][$i]['flags'] = implode(',', $flags_enum);
						$response["rows"][$i]['size'] = $response["rows"][$i]['Size'];
						//$response["rows"][$i]['udate'] = ( $result[$i]['udate'] + $this->functions->CalculateDateOffset()  * 1000 );
						unset($response["rows"][$i]['Size']);
					}
				 }

				return $this->to_utf8($response);
			}
			
			/**
			 * Filtros suportados:
			 * - ['=', 'folderName', $X]
			 * - [
			 * 		'AND',
			 * 		[
			 * 			'AND',
			 * 			['=', 'folderName', $X],
			 * 			['IN', 'messageNumber', $Ys]
			 * 		],
			 * 		['IN', 'labelId', $Zs]
			 * ]
			 * - ['=', 'labelId', $X]
			 * - [
			 * 		'AND',
			 * 		['=', 'folderName', $X],
			 * 		['=', 'labelId', $Y]
			 * ]
			 * - ['IN', 'labelId', $Ys]
			 * - [
			 * 		'AND',
			 * 		['=', 'folderName', $X],
			 * 		['IN', 'labelId', $Ys]
			 * ]			
			 */
			case 'labeled':
			{
				$result = array ( );
				if (isset($criteria["filter"]) && is_array($criteria['filter'])) {
					//TODO - melhorar o tratamento do filter com a lista de todos os labelIds dado pelo interceptor
					$map = array(
						'id' => array(),
						'folderName' => array(),
						'messageNumber' => array(),
						'labelId' => array()
					);
					
					self::parseFilter($criteria["filter"], &$map);
					
					if (count($map['folderName']) == 0) {
						$folders = $this->get_folders_list();
						foreach ($folders as $folder)
							if (isset($folder['folder_id'])) 
								$map['folderName'][] = $folder['folder_id'];
					}

					foreach ($map['folderName'] as $folder) {
						$this->mbox = $this->open_mbox($folder);
						
						foreach ($map['labelId'] as $label) {
							$messagesLabeleds = imap_search($this->mbox, 'UNDELETED KEYWORD "$Label'.$label.'"', SE_UID);
							
							foreach ($messagesLabeleds as $messageLabeled) {
								if (count($map['messageNumber']) > 0 && !in_array($messageLabeled, $map['messageNumber']))
									continue;
									
								$result[] = array (
									'id' => $folder . '/' . $messageLabeled . '#' . $label, 
									'folderName' => $folder,
									'messageNumber' => $messageLabeled,
									'labelId' => $label
								);
							}
						}
						
						imap_close($this->mbox);
						$this->mbox = false;
					}
				}
				
				return $result;
			}
			
			case 'followupflagged':
			{
			
				$result = array ( );
				if (isset($criteria["filter"]) && is_array($criteria['filter'])) {
					//TODO - melhorar o tratamento do filter com a lista de todos os labelIds dado pelo interceptor
					$map = array(
						'id' => array(),
						'folderName' => array(),
						'messageNumber' => array()
					);
					
					self::parseFilter($criteria["filter"], &$map);
					
					if (empty($map['folderName'])) {
						$folders = $this->get_folders_list();
						foreach ($folders as $folder)
							if (isset($folder['folder_id'])) 
								$map['folderName'][] = $folder['folder_id'];
					}

					foreach ($map['folderName'] as $folder) {
						$this->mbox = $this->open_mbox($folder);
						
						foreach ($map['id'] as $followupflagged) {
							$messagesFlaggeds = imap_search($this->mbox, 'UNDELETED KEYWORD "$Followupflag'.$followupflagged.'"', SE_UID);
							
							foreach ($messagesFlaggeds as $messageFlagged) {
								if (count($map['messageNumber']) > 0 && !in_array($messageFlagged, $map['messageNumber']))
									continue;
									
								$result[] = array (
									'id' => $folder . '/' . $messageFlagged . '#' . $followupflagged, 
									'folderName' => $folder,
									'messageNumber' => $messageFlagged
								);
							}
						}
						
						imap_close($this->mbox);
						$this->mbox = false;
					}
				}
						
				return $result;				
			}
		}
    }

    public function read( $URI, $justthese = false )
    {

		switch( $URI['concept'] )
		{
			case 'message':
			{
				return $this->to_utf8( 
					$this->get_info_msg( array('msg_number'=>$URI['id'],
					'msg_folder'=>str_replace( '.', $this->imap_delimiter, $justthese['context']['folder'] )) ) 
				);
			}
			case 'labeled':
			{
				/**
				 * id looks like 'folder/subfolder/subsubfolder/65#13', meaning messageId#labelId
				 */
				list($messageId, $labelId) = explode('#', $URI['id']);
				$folderName = basename($messageId);
				$messageNumber = dirname($messageId);
				
				$result = array();

				if ($folderName && $messageNumber && $labelId) {
					$this->mbox = $this->open_mbox($folderName);
					$messagesLabeleds = imap_search($this->mbox, 'UNDELETED KEYWORD "$Label'.$labelId.'"', SE_UID);
					
					if (in_array($messageNumber, $messagesLabeleds)) {
						$result = array (
							'id' => $URI['id'], 
							'folderName' => $folderName,
							'messageNumber' => $messageNumber,
							'labelId' => $labelId
						);
					}
					imap_close($this->mbox);
					$this->mbox = false;
				}
				
				return $result;
			}
			
			case 'followupflagged':
			{
				/**
				 * id looks like 'folder/subfolder/subsubfolder/65#13', meaning messageId#followupflaggedId
				 */
				list($messageId, $followupflaggedId) = explode('#', $URI['id']);
				$folderName = basename($messageId);
				$messageNumber = dirname($messageId);
				
				$result = array();

				if ($folderName && $messageNumber && $followupflaggedId) {
					$this->mbox = $this->open_mbox($folderName);
					$messagesFlaggeds = imap_search($this->mbox, 'UNDELETED KEYWORD "$Followupflag'.$followupflaggedId.'"', SE_UID);
					
					if (in_array($messageNumber, $messagesFlaggeds)) {
						$result = array (
							'id' => $URI['id'], 
							'folderName' => $folderName,
							'messageNumber' => $messageNumber
						);
					}
					imap_close($this->mbox);
					$this->mbox = false;
				}
				
				return $result;
			}
		}
    }

    public function create( $URI, $data)
    {               
		switch( $URI['concept'] )
		{
			case 'labeled':
			{
				if (isset($data['folderName']) && isset($data['messageNumber']) && isset($data['labelId'])) {
					$this->mbox = $this->open_mbox($data['folderName']);
					imap_setflag_full($this->mbox, $data['messageNumber'], '$Label' . $data['labelId'], ST_UID);

					imap_close($this->mbox);
					$this->mbox = false;

					return array ('id' => $data['folderName'].'/'.$data['messageNumber'].'#'.$data['labelId']);
				}
				return array ();
			}
			case 'followupflagged':
			{
				//deve ser gravado no banco primeiro, obtido o id e, depois, gravado no imap passando o id no parametro $data
				if (isset($data['folderName']) && isset($data['messageNumber']) && isset($data['id'])) {
					list($messageId, $followupflaggedId) = explode('#', $data['id']);
					
					$this->mbox = $this->open_mbox($data['folderName']);
					imap_setflag_full($this->mbox, $data['messageNumber'], '$Followupflagged $Followupflag' . $followupflaggedId, ST_UID);
					
					/**
					 * implementa a possibilidade de listar todas as mensagens sinalizadas atravs da busca
					 */
					//imap_setflag_full($this->mbox, $data['messageNumber'], '$Followupflagged', ST_UID);

					imap_close($this->mbox);
					$this->mbox = false;

					return array ('id' => $data['id']);
				}
				return array ();
			}
			
			case 'message':
			{
				$GLOBALS['phpgw_info']['flags'] = array( 'noheader' => true, 'nonavbar' => true,'currentapp' => 'expressoMail1_2','enable_nextmatchs_class' => True );
                                $return = array();

                                require_once dirname(__FILE__) . '/../../services/class.servicelocator.php';
                                $mailService = ServiceLocator::getService('mail');

                                $msg_uid = $data['msg_id'];
                                $body = $data['body'];
                                $body = str_replace("%nbsp;","&nbsp;",$body);
                                $body = preg_replace("/\n/"," ",$body);
                                $body = preg_replace("/\r/","" ,$body);
                                $body = html_entity_decode ( $body, ENT_QUOTES , 'ISO-8859-1' );					

                                $folder = mb_convert_encoding($data['folder'], "UTF7-IMAP","ISO-8859-1, UTF-8");
                                $folder = @eregi_replace("INBOX[/.]", "INBOX".$this->imap_delimiter, $folder);

								/**
								 * Gera e preenche o field Message-Id do header
								 */
								$mailService->addHeaderField('Message-Id', UUID::generate( UUID::UUID_RANDOM, UUID::FMT_STRING ) . '@Draft');
								
                                $mailService->addTo($data['input_to']);
                                $mailService->addCc( $data['input_cc']);
                                $mailService->addBcc($data['input_cco']);
                                $mailService->setSubject($data['input_subject']);
                                if(isset($data['input_important_message']))
                                        $mailService->addHeaderField('Importance','High');

                                if(isset($data['input_return_receipt']))
                                        $mailService->addHeaderField('Disposition-Notification-To', Config::me('mail'));

                                $isHTML = ( ( array_key_exists( 'type', $data ) && in_array( strtolower( $data[ 'type' ] ), array( 'html', 'plain' ) ) ) ? strtolower( $data[ 'type' ] ) != 'plain' : true );

                                if (!$body) $body = ' ';
                                

                                $mbox_stream = $this->open_mbox($folder);

                                $attachment = json_decode($data['attachments'],TRUE);
                                

                                foreach ($attachment as &$value) 
                                {

                                    if((int)$value > 0) //BD attachment
                                    {
                                         $att = Controller::read(array('id'=> $value , 'concept' => 'mailAttachment'));
                                         
                                         
                                         if($att['disposition'] == 'embedded')
                                         {
                                             $body = str_replace('"../prototype/getArchive.php?mailAttachment='.$att['id'].'"', $att['name'], $body);
                                             $mailService->addStringImage(base64_decode($att['source']), $att['type'], $att['name']);
                                         }
                                         else
                                             $mailService->addStringAttachment(base64_decode($att['source']), $att['name'], $att['type'], 'base64', isset($att['disposition']) ? $att['disposition'] :'attachment' );
                                         
                                         unset($att);
                                    }
                                    else
                                    {
                                        $value = json_decode($value, true);
                                        
                                        switch ($value['type']) {
                                            case 'imapPart':
                                                    $att = $this->getForwardingAttachment($value['folder'],$value['uid'], $value['part']);
                                                    if(strstr($body,'<img src="./inc/get_archive.php?msgFolder='.$value['folder'].'&msgNumber='.$value['uid'].'&indexPart='.$value['part'].'" />') !== false)//Embeded IMG
                                                    {    
                                                        $body = str_ireplace('<img src="./inc/get_archive.php?msgFolder='.$value['folder'].'&msgNumber='.$value['uid'].'&indexPart='.$value['part'].'" />' , '<img src="'.$att['name'].'" />', $body);
                                                        $mailService->addStringImage($att['source'], $att['type'], $att['name']);
                                                    }
                                                    else
                                                        $mailService->addStringAttachment($att['source'], $att['name'], $att['type'], 'base64', isset($att['disposition']) ? $att['disposition'] :'attachment' );
                                                    unset($att);
                                                break;
                                              case 'imapMSG':
                                                    $sub =  $value['name'] ? $value['name'].'.eml' :'no title.eml';
                                                    $mbox_stream = $this->open_mbox($value['folder']);
                                                    $rawmsg = $this->getRawHeader($value['uid']) . "\r\n\r\n" . $this->getRawBody($value['uid']);
                                                    $mailService->addStringAttachment($rawmsg, $sub, 'message/rfc822', '7bit', 'attachment' );
                                                    unset($rawmsg);
                                                break;

                                            default:
                                                break;
                                        }
                                    }

                                }
                                
                                if($isHTML) $mailService->setBodyHtml($body); else $mailService->setBodyText($body);
  
                                if(imap_append($mbox_stream, "{".$this->imap_server.":".$this->imap_port."}".$folder, $mailService->getMessage(), "\\Seen \\Draft"))
                                {
                                    $status = imap_status($mbox_stream, "{".$this->imap_server.":".$this->imap_port."}".$folder, SA_UIDNEXT);
                                    $return['id'] = $status->uidnext - 1;
                                        
                                    if($data['uidsSave'] )
                                        $this->delete_msgs(array('folder'=> $folder , 'msgs_number' => $data['uidsSave']));
                       
                                }
                 
                                if($mbox_stream) imap_close($mbox_stream);

                                return $return;
			}
		}
	}

    public function delete( $URI, $justthese = false, $criteria = false )
    {
		switch( $URI['concept'] )
		{
			case 'labeled':
			{
				list($messageId, $labelId) = explode('#', $URI['id']);
				$folderName = dirname($messageId);
				$messageNumber = basename($messageId);

				if ($folderName && $messageNumber && $labelId) {
					$this->mbox = $this->open_mbox($folderName);
					imap_clearflag_full($this->mbox, $messageNumber, '$Label' . $labelId, ST_UID);

					imap_close($this->mbox);
					$this->mbox = false;
				}
			}
			case 'followupflagged':
			{
				list($messageId, $followupflaggedId) = explode('#', $URI['id']);
				
				$folderName = dirname($messageId);
				$messageNumber = basename($messageId);
			
				if ($folderName && $messageNumber && $followupflaggedId) {

					$this->mbox = $this->open_mbox($folderName);
					imap_clearflag_full($this->mbox, $messageNumber, '$Followupflag' . $followupflaggedId, ST_UID);

					/**
					 * implementa a possibilidade de listar todas as mensagens sinalizadas atravs da busca
					 */
					imap_clearflag_full($this->mbox, $messageNumber, '$Followupflagged', ST_UID);

					imap_close($this->mbox, CL_EXPUNGE);
					$this->mbox = false;
				}
			}
		}

		//TODO - return
	}

    public function deleteAll( $URI, $justthese = false, $criteria = false ) // avaliar
    {}

    public function update( $URI, $data, $criteria = false )
    {
		/**
		 * Os nicos atributos que podem ser alterados no IMAP so folderName e messageId,
		 * porm a operao de update desses atributos no faz sentido para o usurio da DataLayer,
		 * pois na prtica elas so executadas atravs das operaes de CREATE e DELETE.
		 * Assim, para os conceitos "labeled" e "followupflagged", s faz sentido o update de 
		 * atributos gravados no banco de dados e nunca no IMAP.
		 */
	}

//     public function retrieve( $concept, $id, $parents, $justthese = false, $criteria = false )
//     {
// 			return $this->read( array( 'id' => $id, 
// 			    'concept' => $concept, 
// 			    'context' => $parents ), $justthese );
//     }

    public function replace( $URI, $data, $criteria = false )
    {}

    public function close()
    {}

    public function setup()
    {}

    public function commit( $uri )
    { return( true ); }

    public function rollback( $uri )
    {}

    public function begin( $uri )
    {}


    public function teardown()
    {}

    function to_utf8($in) 
    { 
		if (is_array($in)) { 
			foreach ($in as $key => $value) { 
				$out[$this->to_utf8($key)] = $this->to_utf8($value); 
			} 
		} elseif(is_string($in)) { 
				return mb_convert_encoding( $in , 'UTF-8' , 'UTF-8 , ISO-8859-1' ); 
		} else { 
			return $in; 
		} 
		return $out; 
    }
	
	    
    private static function parseFilter($filter ,&$map){
		
		if( !is_array( $filter ) || count($filter) <= 0) return null;
					
		$op = array_shift( $filter );
		switch(strtolower($op))
		{
			case 'and': {
				foreach ($filter as $term)
					self::parseFilter($term ,&$map);
				return;
			}
			case 'in': {
				if(is_array($map[$filter[0]]) && is_array($filter[1]))
					$map[$filter[0]] = array_unique(array_merge($map[$filter[0]], $filter[1]));
				return;
			}
			case '=': {
				$map[$filter[0]][] = $filter[1];
			}
		}
	}

}
